/*
$Id: $
*/

#include "typedefs.h"                   // integer C99 type definitions
#include "mac7111_init.h"               // mac7100 LLD driver
#include "mac7111_esci.h"               // eSCI macros and definitions
#include "mac7111_intc.h"               // INTC module definitions
#include "mac7111_pit.h"                // PIT module definitions
#include "mac7111_pim.h"                // PIM module definitions

#define FSYS 48                         // 48MHz system clock
#define ESCI_BASE ESCI_B_BASE

int main ( void );
void LED_Blinker (void);
void LED_Reverse (void);
unsigned int SCI_putStr (unsigned int esci_base, char* buffer);
unsigned char * _memcpy (unsigned char* dest, const unsigned char* src, int size);
char * u8_to_dec_lj (unsigned char number);
void (* jumptab[64])(void);
void bubble_sort ( unsigned short array[], int size );
void shell_sort ( unsigned short array[], int size );
void sysinit(void);

unsigned short LEDstate;

#ifndef _MAIN_

unsigned char LEDpos;

#else

unsigned char LEDpos = 2;

#define SORTSIZE 128
const unsigned short random_data[SORTSIZE] =
{
  129,  67, 154, 100,  18, 217,  66, 192,
   31, 127, 247,   8, 251, 225,  87,  78,
  107,   4,  36, 105,  51, 132, 255,  92,
  135,  60, 216, 133, 160, 229, 197,   2,
  247,  32, 189, 140, 239,  71,  58, 160,
    1,  90, 160, 104, 141, 193,  90,   8,
   30, 194,  64, 127, 238, 169,  97, 253,
  172, 246, 112, 222,   8,  13, 159,  24,
  238, 156, 189,  66, 171,  85,  60,  51,
  227,  71,   4,  63, 109, 194, 218, 118,
  135,  58, 153,  56, 158, 153, 247, 147,
   61,  96, 121,  66, 198, 178,  52, 135,
  181, 130,  48, 170,   5, 233,  51, 86,
  204, 208, 179, 132, 127, 131, 182, 183,
   79, 174, 215,  72, 105, 188, 170, 239,
  147, 243, 236, 146, 248, 103, 194, 163
};

#endif /* ! #defined _MAIN_ */
