#ifndef _MAC7101_INIT_H_
#define _MAC7101_INIT_H_

#include "typedefs.h"

extern int 
mac7101_crg_init(uint8_t  f_sys);

extern int 
mac7101_pit_init(uint8_t  f_sys, 
                 uint32_t channel, 
                 uint32_t period);

extern int 
mac7101_sci_init(uint8_t  f_sys, 
                 uint32_t esci_base, 
                 uint32_t baudRate,
                 uint32_t opmode);

#define  SECONDS  (uint32_t) 1000000
#define MSECONDS (uint32_t) 1000
#define USECONDS (uint32_t) 1

#endif /* _MAC7101_INIT_H_ */
